package ru.dbotthepony.kommons;

import kotlin.KotlinVersion;
import net.minecraftforge.fml.common.Mod;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

@Mod("kommons")
public class KommonsMod {
	private static final Logger LOGGER = LogManager.getLogger();

	private static void checkIfKotlinIsInstalled() {
		if (!KotlinVersion.CURRENT.isAtLeast(1, 8, 0)) {
			throw new UnsupportedClassVersionError("Installed kotlin version is " + KotlinVersion.CURRENT + ", when at least 1.9.0 is required.");
		}
	}

	public KommonsMod() {
		try {
			checkIfKotlinIsInstalled();
		} catch (Throwable err) {
			if (err instanceof NoClassDefFoundError) {
				for (int i = 0; i < 16; i++)
					LOGGER.fatal("Kommons requires Kotlin to be installed, get Kotlin for Forge from https://github.com/thedarkcolour/KotlinForForge");

				LOGGER.fatal("Kommons requires Kotlin to be installed, get Kotlin for Forge from https://github.com/thedarkcolour/KotlinForForge", err);
				throw new RuntimeException("Kommons requires Kotlin to be installed, get Kotlin for Forge from https://github.com/thedarkcolour/KotlinForForge");
			}

			for (int i = 0; i < 16; i++)
				LOGGER.fatal("Kommons' Kotlin version is not satisfied, get newer Kotlin for Forge from https://github.com/thedarkcolour/KotlinForForge");

			LOGGER.fatal("Kommons' Kotlin version is not satisfied, get newer Kotlin for Forge from https://github.com/thedarkcolour/KotlinForForge", err);

			throw err;
		}

		LOGGER.info("Kommons seems to be loaded");
	}
}
